Fix typo in variable. Now tested on Solaris and Linux, with defaults.
[privoxy.git] / privoxy-generic.init
1 #!/bin/sh 
2
3 #  ********************************************************************
4
5 #  File        :  $Source: /cvsroot/ijbswa/current/privoxy-generic.init,v $
6
7 #  Purpose     :  This shell script takes care of starting and stopping
8 #                 privoxy.
9
10 #  Copyright   :  Written by and Copyright (C) 2001,2002 the SourceForge
11 #                 Privoxy team. http://www.privoxy.org/
12
13 #                 Based on the Internet Junkbuster originally written
14 #                 by and Copyright (C) 1997 Anonymous Coders and
15 #                 Junkbusters Corporation.  http://www.junkbusters.com
16
17 #                 This program is free software; you can redistribute it
18 #                 and/or modify it under the terms of the GNU General
19 #                 Public License as published by the Free Software
20 #                 Foundation; either version 2 of the License, or (at
21 #                 your option) any later version.
22
23 #                 This program is distributed in the hope that it will
24 #                 be useful, but WITHOUT ANY WARRANTY; without even the
25 #                 implied warranty of MERCHANTABILITY or FITNESS FOR A
26 #                 PARTICULAR PURPOSE.  See the GNU General Public
27 #                 License for more details.
28
29 #                 The GNU General Public License should be included with
30 #                 this file.  If not, you can view it at
31 #                 http://www.gnu.org/copyleft/gpl.html
32 #                 or write to the Free Software Foundation, Inc., 59
33 #                 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
34 #
35 # Developer's NOTE: This script should be tested against a true /bin/sh, which
36 # has notable differences from bash. By design, this script does not try to do
37 # too much, so as to be as cross-platform as possible.
38 #
39
40 #  Revisions   :
41 #     $Log: privoxy-generic.init,v $
42 #     Revision 1.3  2002/09/11 01:09:14  hal9
43 #     Better handling of pidfile, and process owner.
44 #
45 #     Revision 1.2  2002/09/08 20:27:58  hal9
46 #     -Rewrote script config section.
47 #     -Added comments to script.
48 #     -Tried to add logic to use a --user privoxy, if available.
49 #     -Minor script changes due to 'echo -n' does not work on a true
50 #      /bin/sh system.
51 #
52 #     Revision 1.1  2002/09/06 00:20:26  hal9
53 #     Creating a generic init script, meant to be used on platforms where don't have
54 #     a custom init script.
55 #
56 #     Revision 1.0  2002/09/05 17:14:32  hal9
57 #
58 #######################################################################
59
60 # Is this needed by Solaris?
61 #ident  "@(#)privoxy  1.0     02/09/05"
62
63 # NOTE: This script may require editing to ensure proper location of 
64 # config file, and the privoxy executable. Care should be taken to ensure 
65 # logfile is writable by $P_USER (logfile is defined in config), and that 
66 # there is suitable write access for $P_PIDFILE.
67
68 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin/:/usr/bin:/sbin:/bin
69 P_NAME=Privoxy
70 # Path to executable.
71 P_DAEMON=privoxy
72 # Full path to location of Privoxy config file. 
73 P_CONF_FILE=./config
74 # Full path to PID file location. Location must be writable by 
75 # whoever runs this script.
76 P_PIDFILE=`pwd`/privoxy.pid
77 # If uncommented, this script will try to run as USER=privoxy, which
78 # may require special handling of config, *.action, trust, logfile, 
79 # jarfile, and pidfile.
80 P_USER=privoxy
81
82 # If a privoxy user is specified, lets try that. /bin/sh does not seem to 
83 # know about $UID.
84 if [ "$USER" = "root" ] && [ -n "$P_USER" ] && id $P_USER >/dev/null; then
85   P_OWNER=$P_USER
86 else 
87   P_OWNER=$USER
88 fi
89
90 if [ ! -f $P_CONF_FILE ]; then
91   echo "Can't find $P_CONF_FILE, exiting."
92   exit 1
93 fi
94
95 case "$1" in
96  
97  start)
98      if [ -f $P_PIDFILE ]; then
99        if kill -0 `cat $P_PIDFILE`; then
100          echo "Error: $P_NAME is already running, exiting."
101          exit 1
102        else
103          rm -f $P_PIDFILE
104        fi
105      fi
106
107         $P_DAEMON --pidfile $P_PIDFILE --user $P_OWNER $P_CONF_FILE 2>/dev/null
108      
109      if [ $? -eq 0 ]; then
110        echo "Starting $P_NAME, OK." 
111      else
112        echo "Starting $P_NAME, Failed."
113        rm -f $P_PIDFILE
114      fi
115      ;;
116  
117  restart)
118      $0 stop
119      $0 start
120      ;;
121  
122  stop)
123      test ! -f $P_PIDFILE && echo "No $P_PIDFILE file found, exiting." && exit 1
124      kill `cat $P_PIDFILE` &&\
125      echo "Stopping $P_NAME, OK." || echo "Stopping $P_NAME, failed."
126      ;;
127  
128  *)
129      echo "Usage: $0 {start|stop|restart}"
130      exit 1
131      ;;
132
133 esac
134
135 exit 0